unit vgichoic;
interface
uses Objects,graph,vgilow,vgikeys,vgiText,vgibase,vgidlg,vgimenu;
type
    PChoice = ^TChoice;
    TChoice = object(TTextLine)
               Menu:PMenuBox;
               Data:Integer;
               Constructor Init(X1,Y1,X2,Y2:Integer;AMenu:PMenuBox);
               Function DataSize:Word;virtual;
               Procedure Select;virtual;
               Procedure Unselect;virtual;
               Procedure GetData(var Rec);virtual;
               Procedure SetData(var Rec);virtual;
               Function Handle(Code:Word):Integer;virtual;
               Destructor Done;virtual;
              end;
const   RChoice :TStreamRec = (ObjType:130;
                             VmtLink:ofs(TypeOf(TChoice)^);
                             Load:@TChoice.Load;
                             Store:@TChoice.Store);
Implementation
Constructor TChoice.Init(X1,Y1,X2,Y2:integer;AMenu:PMenuBox);
begin
 TControl.Init(X1,Y1,X2,Y2);
 Flags:=Flags or vfSelectable;
 Menu:=Amenu;
 With Menu^.Menu^ do
 if Default=nil then Default:=Items;
end;
Procedure TChoice.Select;
begin
 Text^[2]:=Chr(taInverse);
 if Visible then Draw;
end;
Procedure TChoice.Unselect;
begin
 Text^[2]:=Chr(0);
 if Visible then Draw;
end;
Function TChoice.DataSize:Word;
begin
 DataSize:=2;
end;
Procedure TChoice.GetData(var Rec);
var D:Integer absolute Rec;
begin
 D:=Data;
end;
Procedure TChoice.SetData(var Rec);
var D:Integer absolute Rec;
begin
 Data:=D;
 if Visible then Draw;
end;
Function TChoice.Handle(Code:Word):Integer;
var Cmd:Integer;C:char;P:PMenuItem;
begin
   if (Owner^.Current=@Self)and(Code=kbSpace)or (Code and $FF00=kbMousePressed) then
     Handle:=Menu^.Execute
    else
    Handle:=Menu^.Handle(Code);
end;
Function TChoice.GetText;
begin
 GetText:=Tilda2CC(Menu^.Menu^.Default^.Name^,0,0);
end;
Destructor TChoice.Done;
begin
 Dispose(Menu,Done);
 TTextLine.Done;
end;
end.
