{$R+}
{****************************************************************************}
{*                                                                          *}
{*                          Vitus Graphic Interface                         *}
{*                               Version 2.6                                *}
{*           Easy, event driven, object oriented graphic interface          *}
{*                       for Turbo Pascal 5.5 or higher                     *}
{*                 Copyright (c) by SoftWeyr, 1991-1993                     *}
{*                                                                          *}
{*                              VGILOW.PAS                            *}
{*  Event manager,ࠡ  ஬, -  PutImage/GetImage          *}
{****************************************************************************}

unit VGILow;
interface
uses objects,dos,graph,VgiKeys;
{****************   ᪨************************************}
Type TCursorShape = record
                      HotX,HotY:Integer;
                      ScreenMask,
                      CursorMask:Array[0..15]of Word;
                    end;
       {    }

     PMouseCursor = ^TMouseCursor;
     PCursor = PMouseCursor;
     TMouseCursor = object ( TObject )
                 Shape:TCursorShape;
                Constructor Init;
                Procedure Show;virtual;
                Procedure Hide;virtual;
                Procedure Move(X,Y:Integer);virtual;
                Function GetX:Integer;virtual;
                Function GetY:Integer;virtual;
                Procedure SetShape(var AShape:TCursorShape);virtual;
                Procedure GetShape(var AShape:TCursorShape);
                Procedure VideoModeChanged;virtual;
                Destructor Done;virtual;
               end;
       {  ࠩ }
       PScreenCursor = ^TScreenCursor;
       TScreenCursor = object ( TMouseCursor )
                                         {.$IFDEF VER55}
                        ISize:Integer;{  ࠭}
                        Pos:TPoint;
                        Visible:Integer;
                                                ScreenMask,CursorMask,SaveScreen:Pointer;
                                         {.$ENDIF}
                        Constructor Init;
                        Procedure Show;virtual;
                        Procedure Hide;virtual;
                        Procedure Move(X,Y:Integer);virtual;
                        Function GetX:Integer;virtual;
                        Function GetY:Integer;virtual;
                        Procedure SetShape(var AShape:TCursorShape);virtual;
                        Destructor Done;virtual;
                                                Procedure VideoModeChanged;virtual;
                                         {.$IFNDEF VER55}
{                       private
                        ISize:Integer;{  ࠭}
{                        Pos:TPoint;
                        Visible:Integer;
                                                ScreenMask,CursorMask,SaveScreen:Pointer;
}                                        {.$ENDIF}
                        Procedure Reshape;
                       end;
     {      ⢨ প  ࠩ஬
      㦭 ० ࠭}
      PSVGACursor = ^TSVGACursor;
      TSVGACursor = object ( TScreenCursor )
                        Constructor Init;
                        Procedure Move(X,Y:Integer);virtual;
                        Destructor Done;virtual;
                        Procedure VideoModeChanged;virtual;
                      end;
{ 㪠⥫  }
var Cursor:PCursor;
{ଠ   㬮砭}
Const DefaultShape:TCursorShape=
          (HotX:0;HotY:0;
          ScreenMask:($1FFF,$07FF,$03FF,$80FF,$803F,$C00F,$C003,$E001,$F000,$F000,$F800,$FC01,$FC01,$FE00,$FF00,$FF18);
          CursorMask:($C000,$E000,$7800,$3E00,$3F00,$1FC0,$1FF0,$0FFC,$07FE,$07FF,$03FE,$01FC,$01FC,$00FE,$0067,$0043));

{******************** ࠡ⪠ ᮡ⨩ ****************************}
var
    KbdFlags:Byte absolute $40:$17;

    {न ᫥ ᮡ, ⠭ 㭪樥 GetEvent}
    Event,

    {᪨ न ᫥ ᮡ  ⠩,
     ⠭ 㭪樥 GetEvent}
    TabletPos:TPoint;
        EventInfo:Pointer;
    {᫨ 0,  ५ ६ }
    const EnableArrows:integer=0;

    {頥  ࢮ ࠡ⠭ ᮡ}
    Function GetEvent:word;

        {頥 樮஢ ᮡ⨥  ।. ᫨ ।  -
         頥 False}
        Function PutEvent(Code:Word;X,Y:Integer):boolean;

        {頥      । ᮡ⨩}

        function PutCommand(Code:Word):boolean;

        {頥  砫 । ᮡ⨥}

        Procedure PushEvent(Code:Word;Info:Pointer);
    {頥 । ᮡ⨩}
    Procedure ClearEventQueue;
    {True,᫨ । ᮡ⨩  }
    Function EventReady:Boolean;

    {襭/饭 ࠢ ஬   }
    Procedure EnableKeyMove;inline($FF/$0E/>EnableArrows);{Dec(EnableArrows)}
    Procedure DisableKeyMove;inline($FF/$06/>EnableArrows);{Inc(EnableArrows)}

    {८ࠧ न ⠩  ࠭}
    { 㫠
      Dest.X:=Round (AX*Src.X+BX*Src.Y)+CX;
      Dest.Y:=Round (AY*Src.X+BY*Src.Y)+CY;}
    Procedure Tablet2Scr(Src:TPoint;var Dest:TPoint);
    {ࠬ ८ࠧ}
    Const AX:real=1.0;AY:Real=0.0;
          BX:real=0.0;BY:Real=-1.0;
          CX:Integer=0;CY:Integer=0;

{****************** ⠭ ० *****************************}
const
                { ⠭ ࠩ஢}
                VGA256 = 16;
                VESA16 = 17;
                VESA256 = 18;
                { ⥫ ⮢}
                ScriptFont=5;
                SimplexFont=6;
                TSCRFont = 7;
                LComFont = 8;
                EuroFont = 9;
                { ࠧ襭 ०}
                gmf256 = 1;{ ᯮ짮 256-梥 ० SVGA.
                                         Protected Mode }
                gmfOnly256 = 2;{ ᯮ짮 ०   祬 256 .}
                gmfLoRes   = 4;{ ᯮ짮 ० 320200}
                gmfMono    = 8;{ ᯮ짮 ୮- ०}
                gmfSVGA    = 16; { ᯮ짮 ० SVGA}
var


 { ᫥ 믮 InitVGI ࠭ ⥪騩 . ࠩ  .
 ०. E᫨  InitVGI   - ⫨筮  Detect,
 㤥 ⠭ ॡ㥬 . ०}

 GraphDriver, GraphMode :Integer;

    {  ⠫,   ᪠ 䠩 CHR  BGI}
    BGIPath : PathStr;
    {㭪 ࠡ⪨ 訡 樠樨}
    InitError:function (Code:Integer):Boolean;

{ । 맮 InitVGI    䫠 gmfXXX}
VGIDip:Byte;
    { ࠭ 祭 GetMaxX  GetMaxY.   ६ -
     ॥, 祬 맮 㭪権}
    MaxGraphX,MaxGraphY:Integer;

    { 梥, १ࢨ஢  䥩 ᮪ ஢}
    ForeColor,BackColor:Integer;
    Procedure SwapColors;inline
     ($A1/>ForeColor    {MOV AX,ForeColor}
     /$87/$06/>BackColor{XCHG AX,BackColor}
     /$A3/>ForeColor    {MOV ForeColor,AX});
    { 뢠  COM-⮢ - ࠭  砩 ᯮ짮
     ⠩}
  var
    SaveInt0B,SaveInt0C:Pointer;

{樠 䨪   ࠡ⪨ ᮡ⨩.}
Procedure InitVGI;

{⮦ ᥣ 襯᫥}
Procedure DoneVGI;
{    InitGraph/CloseGraph}
Procedure InitEvents;
Procedure DoneEvents;
{ 楤 SetGraphMode   Graph.  GraphMode,
 MaxGraphX  MaxGraphY,  ⠪  ࠬ , ᫨ 室}
Procedure SetGraphMode(Mode: integer);
{楤, ।  InstallUserDriver. ᥣ 頥 訡}
function FalseDetect:Integer;

{*****************   ஢ 䨪 ********************}

Type PImage = ^TImage;
     TImage = Record
               XSize,YSize:Integer;
               Data:Array[0..65000] of byte;
              end;

{ ஬ ⮢    Image  ⥪饣
 ᪮ ०. Image  ,  뢮  ࠭
  楤ன PutImage XSize = XMax-XMin YSize= YSize - YMin}
Function Bits2Image(Xsize,YSize:Integer;var BitMap; Fore,Back:Integer):PImage;

{⠥  ࠭  ࠧ頥  ᪮  }
Function ImageToHeap(X1,Y1,X2,Y2:Integer):PImage;

{뤥  ᪮      ࠧ஢}
Function NewImage(X1,Y1,X2,Y2:Integer):PImage;

{⮦   Image, ࠧ饭  ᪮  㭪樥
 NewImage,ImageToHeap  Bits2Image}
 Procedure DisposeImage(P:PImage);
{***************************  etc ***************************************}
{  楤 Sound  CRT}
Procedure Sound(Hz:Word);
{뤠 ⪨ .  Write(#7)}
Procedure Beep;inline($B8/$07/$0E/$CD/$10);
{  楤 NoSound  CRT}
Procedure NoSound;
{ 楤 Delay  Crt. ६ প 㣫  楫 ᫠
 ⨪ ⠩. (1 ⨪ = 55 ᥪ)}
Procedure Delay(MS:Word);
{宦  Delay,  뢠 প   ᮡ. (뢠
 ⮫쪮  樠஢  ᮡ⨩}
Procedure Sleep(Ms:Word);
{頥 ᫮ ᥪ㭤, 襤襥  砫 ⮪}
Function Timer:LongInt;
{***********************  Inline ************************************}
Procedure Sti;Inline($FB);
Procedure Cli;Inline($FA);
Procedure PushF;inline($9C);
Procedure PopF;inline($9D);

{}
{}
{}
{Implementation}
{}
{}
{}
Const EventQHead:integer=1;
          EventQTail:Integer=1;
          EventQSize = 32;
          KbdStart = $1E;
          KbdEnd = $3C;
Implementation
{************ ७ ⨯  ६ Event manager' *****************}
{। ᮡ⨩}
var Events:Array[1..EventQSize] of TPoint;
          KbdQHead:Word absolute $40:$1A;
          KbdQTail:Word absolute $40:$1C;
{࠭ ExitProc}
    SaveExitProc:Pointer;
{****************************************************************************}
{*                             Procedure PutCommand                         *}
{****************************************************************************}
Function PutCommand(Code:Word):Boolean;
  const
    KbdStart = $1E;
    KbdEnd = $3C;
var
    SaveKbdTail : Word;
begin
 pushf;
 cli;
 PutCommand:=True;
    SaveKbdTail := KbdQTail;
    if KbdQTail = KbdEnd then
      KbdQTail := KbdStart
    else
      Inc(KbdQTail, 2);
    if KbdQTail = KbdQHead then
     begin
      KbdQTail := SaveKbdTail;
      PutCommand:=False;
     end
    else
      MemW[$40:SaveKbdTail] := Code;

  popf;
end;
Function CheckZero(KeyCode:Word):Word;inline
($58        {       POP     AX    }
/$80/$FC/$00{       CMP     AH,00 }
/$75/$04    {       JNZ     @@1   }
/$B4/$38    {       MOV     AH,38H}
/$EB/$07    {       JMP     Exit  }
/$80/$FC/$38{  @@1: CMP     AH,38H}
/$75/$02    {       JNZ     Exit  }
/$B4/$00);  {       MOV     AH,00 }
            {  Exit:              }

{****************************************************************************}
{*                             Procedure PutEvent                           *}
{****************************************************************************}
Function PutEvent(Code:Word;X,Y:Integer):Boolean;
var I:Integer;
begin
 PushF;
 cli;
 if (Code>$F000)and(EventReady) then
  begin
   I:=KbdQTail;
   if i=kbdStart then i:=kbdEnd else dec(i,2);
   if MemW[$40:I]=CheckZero(Code) then
    begin
     i:=EventQTail;
     if i=1 then i:=EventQSize else dec(i);
     Events[i].X:=X;
     Events[i].Y:=Y;
     Popf;
     Exit;
    end
  end;
 if PutCommand(Code) then
  begin
    I:=EventQTail;
    Inc(EventQTail);
    if EventQTail > EventQSize then
      EventQTail := 1;
    Events[i].X:=X;
    Events[i].Y:=Y;
    PutEvent:=True;
  end
  else
   PutEvent:=False;
  popf;
end;
{****************************************************************}
{*               Procedure PushEvent                            *}
{****************************************************************}
Procedure PushEvent(Code:Word;Info:Pointer);
var i:integer;
begin
 cli;
 if KbdQHead=KbdStart then kbDQHead:=KbdEnd else
 dec(kbdQHead,2);
 if kbdQHead=kbdQTail then dec(kbdQTail,2);
  MemW[$40:kbdQHead]:=CheckZero(Code);
 if Code>=$C000 then
  begin
   if EventQHead=1 then EventQHead:=EventQSize else
    dec(EventQHead);
   Pointer(Events[EventQHead]):=Info;
  end;
 sti
end;



Procedure ClearEventQueue;
{******************************************************}
{*               ClearEventQueue                      *}
{******************************************************}
Begin
 cli;
 KbdQTail:=$1E;
 KbdQHead:=$1E;
 EventQHead:=1;
 EventQTail:=1;
 sti
end;{______of procedure ClearEventQueue }

Function EventReady:Boolean;
{******************************************************}
{*               EventReady                           *}
{******************************************************}
Begin
 EventReady:=KbdQTail<>KbdQHead;
end;{______of function EventReady }

{****************************************************************************}
{*                            Procedure Tablet2Scr                          *}
{****************************************************************************}
Procedure Tablet2Scr(Src:TPoint;var Dest:TPoint);
begin
      Dest.X:=Round (AX*Src.X+BX*Src.Y)+CX;
      Dest.Y:=Round (AY*Src.X+BY*Src.Y)+CY;
end;


{**************************************************************************}
{*                             Function FromQueue                         *}
{*              न⭮ । न ᮡ        *}
{**************************************************************************}
Function FromQueue:Pointer;
begin
 cli;
  FromQueue:=Pointer( Events[EventQHead]);
 if EventQHead=EventQSize then EventQHead:=1 else
  inc(EventQHead);
 sti;
end;

{   ६饭 蠬  㬮砭}
Const CursorStep:Integer=4;
{, ⠭ ࠡ稪 뢠 $1B}
Function ReadKeyWord:Word;
{**************************************************************************}
{*                             Function ReadKeyWord                       *}
{*                  ᮡ                 *}
{**************************************************************************}
var W:Word;
begin
 While not EventReady do;
 W:=MemW[$40:kbdQHead];
 if (Lo(W)=$E0)then
  if(Hi(W)<>$23)and(Hi(W)<>0) then
  ReadKeyWord:=CheckZero(W) and $FF00
  else ReadKeyWord:=$23E0
 else
  ReadKeyWord:=W;
 if kbdQHead=kbdEnd then kbdQHead:=kbdStart else
  inc(kbdQHead,2);
end;
Function GetEvent:word;
{******************************************************}
{*               GetEvent                             *}
{******************************************************}
var     Step:Byte;Key:Word;OldEvent:TPoint;
Begin
 PushF;
 Cli;
 GetEvent:=0;
 if EventReady then
  begin
   Key:=ReadKeyWord;
   if key>=kbMouseReleased then
    Pointer(Event):=FromQueue
   else
        if key>=kbButtonReleased then
        begin
         Pointer(TabletPos):=FromQueue;
         Tablet2Scr(TabletPos,Event);
        end
        else
   if (key>=$C000)and(Hi(Key)<>$E0) then EventInfo:=FromQueue else
   begin
   if EnableArrows=0 then
        begin
        OldEvent:=Event;
    if KbdFlags and $3<>0 then step:=1 else Step:=CursorStep;
    case key of
        kbUp:begin Dec(Event.Y,Step);key:=kbMouseMoved;if Event.Y<0 then Event.Y:=0 end;
        kbDown:begin Inc(Event.Y,Step);key:=kbMouseMoved;
                    If Event.Y>MaxGraphY then Event.Y:=MaxGraphY end;
        kbLeft:begin Dec(Event.X,Step);key:=kbMouseMoved;
                    if Event.X<0 then Event.X:=0 end;
        kbRight:begin Inc(Event.X,Step);key:=kbMouseMoved;
                 if Event.X>MaxGraphX then Event.X:=MaxGraphX end;
        kbEnter:begin Key:=kbMousePressed+kbMouseLeft;
                                  PushEvent(kbMouseReleased,Pointer(Event))
                                end;
        kbSpace:begin Key:=kbMousePressed+kbMouseRight;
                                 PushEvent(kbMouseReleased,Pointer(Event)); end;
    kbGrayPlus:begin
               if CursorStep<64 then CursorStep:=CursorStep*2; exit
               end;
    kbGrayMinus:begin
               if CursorStep>4 then CursorStep:=CursorStep div 2; exit
               end;
         end;{Key}
         if (LongInt(OldEvent)<>LongInt(Event))and(OldEvent.X=Cursor^.GetX)and(OldEvent.Y=Cursor^.GetY)
          then Cursor^.Move(Event.X,Event.Y);
        end;
    end;
        GetEvent:=Key;
   end {else ClearEventQueue};
  popf;
end;{______of function GetEvent }


{************************ ।⢠  ࠡ   **********************}
{$F+}

Procedure MouseHandler;external;

Procedure SVGAMouseHandler;external;

Function InitMouse(Handler:Pointer):Boolean;external;

Procedure DoneMouse;external;

Procedure SetMouseRange(X1,Y1,X2,Y2:Integer);External;

{$F-}

{************************ ⮤ ꥪ TMouseCursor ***********************}


Constructor TMouseCursor.Init;
begin
 if not InitMouse(@MouseHandler) then fail;
 SetMouseRange(0,0,MaxGraphX,MaxGraphY);
 Event.X:=GetX;
 Event.Y:=GetY;
 SetShape(DefaultShape);
end;

Procedure TMouseCursor.Show;external;

Procedure TMouseCursor.Hide;external;

Procedure TMouseCursor.Move(X,Y:Integer);external;

Function TMouseCursor.GetX:Integer;external;

Function TMouseCursor.GetY:Integer;external;

Procedure TMouseCursor.SetShape(var AShape:TCursorShape);external;
{$IFDEF Ver70}
  {$L MOUSE7.OBJ}
{$ELSE}
  {$L Mouse.Obj}
{$ENDIF}

Procedure TMouseCursor.GetShape(var AShape:TCursorShape);
begin
 AShape:=Shape;
end;
Procedure TMouseCursor.VideoModeChanged;
begin
 if InitMouse(@MouseHandler) then;
 SetMouseRange(0,0,MaxGraphX,MaxGraphY);
end;
Destructor TMouseCursor.Done;
begin
 DoneMouse;
end;

{************ ⮤ ꥪ TScreenCursor ******************************}
Constructor TScreenCursor.Init;
begin
 TObject.Init;
 Pos.X:=Succ(MaxGraphX) div 2;
 Pos.Y:=Succ(MaxGraphY) div 2;
 GetMem(SaveScreen,ImageSize(0,0,15,15));
 Visible:=-1;
 Event:=Pos;
 SetShape(DefaultShape);
end;
Procedure TScreenCursor.Show;
var Sx,SY,i,j:Integer;
begin
 pushf;
 cli;
 inc (Visible);
 if (Visible=0) then
  begin
   SX:=Pos.X-Shape.HotX;
   Sy:=Pos.Y-Shape.HotY;
   if (SX>=0)and(SX+15<=MaxGraphX)and(SY>=0) then
    begin
     GetImage(Sx,Sy,Sx+15,Sy+15,SaveScreen^);
     PutImage(Sx,Sy,ScreenMask^,AndPut);
     PutImage(Sx,SY,CursorMask^,OrPut);
    end
  end;
  popf;
end;
Procedure TScreenCursor.Hide;
var Sx,SY:Integer;
begin
 pushf;
 cli;
 if Visible=0 then
  begin
   SX:=Pos.X-Shape.HotX;
   Sy:=Pos.Y-Shape.HotY;
   if (SX>=0)and(SX+15<=MaxGraphX)and(SY>=0) then
     PutImage(Sx,SY,SaveScreen^,CopyPut);
  end;
 Dec(Visible);
 popf;
end;
Procedure TScreenCursor.Move(X,Y:Integer);
begin
 Hide;
 Pos.X:=X;
 Pos.Y:=Y;
 if X<0 then X:=0 else if X>MaxGraphX then X:=MaxGraphX;
 if Y<0 then Y:=0 else if Y>MaxGraphY then Y:=MaxGraphY;
 Show;
end;
Function TScreenCursor.GetX:Integer;
begin
 GetX:=Pos.X;
end;
Function TScreenCursor.GetY:Integer;
begin
 GetY:=Pos.Y;
end;
Procedure TScreenCursor.SetShape(var AShape:TCursorShape);
begin
 Hide;
 Shape:=AShape;
 Reshape;
 Show;
end;
Destructor TScreenCursor.Done;
begin
 Hide;
 FreeMem(CursorMask,ISize);
 FreeMem(ScreenMask,ISize);
 FreeMem(SaveScreen,ISize);
end;
Procedure TScreenCursor.VideoModeChanged;
begin
 Visible:=-1;
 Pos.X:=Succ(MaxGraphX)div 2;
 Pos.Y:=Succ(MaxGraphY)div 2;
 Reshape;
end;
Procedure TScreenCursor.Reshape;
var T:TCursorShape;I:Integer;
begin
 For i:=0 to 15 do
 begin
  T.CursorMask[i]:=Swap(Shape.CursorMask[i]);
  T.ScreenMask[i]:=Swap(Shape.ScreenMask[i]);
 end;
 if ISize<>0
  then
  begin
   FreeMem(CursorMask,ISize);
   FreeMem(ScreenMask,ISize);
   FreeMem(SaveScreen,ISize);
  end;
 ISize:=ImageSize(0,0,15,15);
 CursorMask:=Bits2Image(15,15,T.CursorMask,255,0);
 ScreenMask:=Bits2Image(15,15,T.ScreenMask,255,0);
 GetMem(SaveScreen,ISize);
end;
Constructor TSVGACursor.Init;
var Mode:Byte;InitResult:Boolean;
begin
 Mode:=Mem[$40:$49];
 mem[$40:$49]:=$6;
 initResult:=InitMouse(@SVGAMouseHandler);
 mem[$40:$49]:=mode;
 if not InitResult then Fail;
{ Graph.SetGraphMode(Mode);}
 TScreenCursor.Init;
 SetMouseRange(0,0,MaxGraphX,MaxGraphY);
 Move(Pos.X,Pos.Y);
end;
Procedure TSVGACursor.Move(X,Y:Integer);
begin
 TMouseCursor.Move(X,Y);
 TScreenCursor.Move(X,Y);
end;
Destructor TSVGACursor.Done;
begin
 TScreenCursor.Done;
 DoneMouse;
end;
Procedure TSVGACursor.VideoModeChanged;
var Mode:Byte;
begin
 Mode:=Mem[$40:$49];
 Mem[$40:$49]:=6;
 if Initmouse(@SVGAMouseHandler) then;
 Mem[$40:$49]:=Mode;
 SetMouseRange(0,0,MaxGraphX,MaxGraphY);
 TScreenCursor.VideoModeChanged;
end;

{***************   Imag' *******************************}

Function NewImage(X1,Y1,X2,Y2:Integer):PImage;
{******************************************************}
{*               NewImage                             *}
{******************************************************}
var P:PImage;
    Size:Word;
Begin
  Size:=ImageSize(X1,Y1,X2,Y2);
  if (Size=0)or(Size>MaxAvail) then NewImage:=nil
   else
    begin
     GetMem(P,Size);
     P^.Xsize:=X2-X1;
     P^.YSize:=Y2-Y1;
 {Patch VGA256.BGI bug ----}
 if GraphDriver=VGA256 then begin Inc(P^.XSize);Inc(P^.YSize) end;
 {End Patch ---------------}
     NewImage:=p;
    end;
end;{______of function NewImage }

Function ImageToHeap(X1,Y1,X2,Y2:Integer):PImage;
{******************************************************}
{*               ImageToHeap                          *}
{******************************************************}
var P:Pimage;
Begin
  P:=NewImage(X1,Y1,X2,Y2);
  if P<>nil then GetImage(X1,Y1,X2,Y2,P^);
  ImageToHeap:=P;
end;{______of function ImageToHeap }

Procedure DisposeImage(P:PImage);
{******************************************************}
{*               DisposeImage                         *}
{******************************************************}
Begin
 if P=nil then exit;
 {Patch VGA256.BGI bug ----}
 if GraphDriver=VGA256 then begin Dec(P^.XSize);Dec(P^.YSize) end;
 {End Patch ---------------}
 FreeMem(P,ImageSize(0,0,P^.XSize,P^.YSize));
end;{______of procedure DisposeImage }

Function Bits2Image(XSize,YSize:Integer;Var BitMap;Fore,Back:Integer):PImage;
{******************************************************}
{*               Bits2Image                            *}
{******************************************************}
var P:Pimage;
    BitWidth:Integer;
    Var B:Array[0..65521] of byte absolute BitMap;
Procedure DirectCopy;
var i,j,k:Integer;
begin
 K:=0;
 if Fore<>0 then
 For i:=0 to YSize do
  For j:=1 to BitWidth do
   begin
   P^.Data[K]:=B[K];inc(k);
   end
  else
 For i:=0 to YSize do
  For j:=1 to BitWidth do
   begin
   P^.Data[K]:=Not B[K];inc(k);
   end
end;
Procedure Planes(N:Integer);
var i,j,k,l:Integer;
   Mask:byte;
begin
 K:=0;
 For i:=0 to YSize do
  For l:=0 to pred(n) do
   begin
   Mask:=8 shr l;
   if Mask and Fore<>0 then
    if Mask and Back=0 then
       For j:=0 to Pred(BitWidth) do
        begin
         P^.Data[K]:=B[I*BitWidth+j];
         inc(K);
        end
    else
       For j:=0 to Pred(BitWidth) do
        begin
         P^.Data[K]:=$FF;
         inc(K);
        end
   else
  if Mask and Back<>0 then
       For j:=0 to Pred(BitWidth) do
        begin
         P^.Data[K]:=not B[I*BitWidth+j];
         inc(K);
        end
    else
       For j:=0 to Pred(BitWidth) do
        begin
         P^.Data[K]:=0;
         inc(K);
        end
   end
end;
Procedure DuplicateBits;
var i,j,k,l:Integer;
    W,W1:Word;
    D:Byte;
var Mf,mb:Array[0..7]of word;
begin
  fore:=Fore and 3;
  back:=Back and 3;
  For i:=0 to 7 do
   begin
    MF[i]:=Word(Fore);
    MB[i]:=Word(Back);
    Fore:=Fore shl 2;
    Back:=Back shl 2;
   end;
 K:=0;
 For i:=0 to YSize do
  For j:=1 to BitWidth do
   begin
    W:=0;
    D:=B[k];
    for l:=0 to 7 do
     if (1 shl l) and D<>0 then W:=W or Mf[l] else W:=w or MB[l];
    P^.Data[2*K]:=Hi(W);
    P^.Data[2*K+1]:=Lo(W);inc(k);
   end;
end;
Procedure BitToByte;
var i,j,k,l:Integer;
    W:Word;
    D:Byte;
begin
 K:=0;
 L:=0;
 D:=128;
 For i:=0 to YSize do
  For j:=0 to XSize do
   begin
    if B[k] and D<>0 then
     P^.Data[L]:=Fore else P^.Data[L]:=Back;
    inc(l);
    D:=D shr 1;
    if d=0 then begin D:=128; inc(K) end;
   end;
end;

Begin
  BitWidth:=Succ(XSize div 8);
  P:=NewImage(0,0,XSize,YSize);
  if P<>nil then
  Case GraphDriver of
  CGA:if GraphMode=CgaHi then DirectCopy
      else DuplicateBits;
  HercMono:DirectCopy;
  Ega64:if GetMaxColor=3 then Planes(2) else Planes(4);
  Ega,VGA,VESA16:Planes(4);
  VGA256:begin BitToByte;end;
  VESA256:BitToByte;
 end;
 Bits2Image:=p;
end;{______of function Bits2Image }
{*****************   প *****************************************}
Procedure Sound(hz:Word);external;

Procedure NoSound;external;

{$L Sound.obj}

const MaxTimer = 1570909;
var BiosTimer:LongInt absolute $40:$6C;

Procedure Delay(Ms:Word);
{******************************************************}
{*               Delay                                *}
{******************************************************}
var T:LongInt;
begin
 Sti;{ 直 砩}
 T:=BiosTimer+Ms div 55;
 if T>MaxTimer then T:=T-MaxTimer;
 Repeat until T<=BiosTimer;
end;{______of procedure Delay }
Procedure Sleep(Ms:Word);
{******************************************************}
{*               Sleep                                *}
{******************************************************}
var T:LongInt;
begin
 ClearEventQueue;
 Sti;{ 直 砩}
 T:=BiosTimer+Ms div 55;
 if T>MaxTimer then T:=T-MaxTimer;
 Repeat
  if EventReady then Exit;
 until T<=BiosTimer;
end;{______of procedure Sleep }

Function Timer:LongInt;
{******************************************************}
{*               Timer                                *}
{******************************************************}
begin
 Timer:=BiosTimer*55;
end;{______of function Timer }

{********************** 樠 䨪 ******************************}
Procedure InitEvents;
var i:Integer;
begin
  MaxGraphX:=GetMaxX;
  MaxGraphY:=GetMaxY;
  BackColor:=GetMaxcolor;
  if BackColor=255 then SetRgbPalette(255,63,63,63)
  else
   if (BackColor=15)and(GraphDriver<>EGA) then
    begin
     For i:=1 to 15 do
      SetPalette(i,i);
     SetRGBPalette(15,63,63,63);
    end;
  ForeColor:=0;
  {᫨  諨,  室}
  {࠭ ஢ 뢠  .⮢}
  GetIntVec(11,SaveInt0B);
  GetIntVec(12,SaveInt0C);
  Cursor:=nil;
  { }
  if GraphDriver<Vga256 then
  Cursor:=New(PMouseCursor,Init)
  else Cursor:=New(PSVGACursor,Init);
  if Cursor = nil then Cursor:=New(PScreenCursor,Init);
  SaveExitProc:=ExitPRoc;
  ExitProc:=@DoneVGI;
end;
Procedure InitVGI;
{******************************************************}
{*               InitVGI                              *}
{******************************************************}
var I,DSave:Integer;
Begin
  {室  ᪨ ०}
  DSave:=GraphDriver;
  repeat
  GraphDriver:=DSave;
  InitGraph(GraphDriver,GraphMode,BGIPath);
  i:=GraphResult;
  if i<>0 then
   if @InitError=nil then
     begin
      Writeln(GraphErrorMsg(i));
      halt
     end
    else
     if not InitError(i) then Halt;
  until i=0;
  InitEvents;
end;{______of procedure InitVGI }
Procedure DoneEvents;
begin
 ExitProc:=SaveExitProc;
 SetIntVec(11,SaveInt0B);
 SetIntVec(12,SaveInt0C);
 if Cursor<>nil then Dispose(Cursor,Done);
end;
Procedure DoneVGI;
{******************************************************}
{*               DoneVGI                              *}
{******************************************************}
Begin
 DoneEvents;
 CloseGraph;
end;{______of procedure DoneVGI }

Procedure SetGraphMode(Mode:Integer);
{******************************************************}
{*               SetGraphMode                         *}
{******************************************************}
Begin
 Graph.SetGraphMode(Mode);
 if GraphResult<>0 then;
  GraphModE:=GetGraphMode;
  BackColor:=GetMaxcolor;
  if BackColor=255 then SetRgbPalette(255,63,63,63);
  ForeColor:=0;
  MaxGraphX:=GetMaxX;
  MaxGraphY:=GetMaxY;
 Cursor^.VideoModeChanged;
end;{______of procedure SetGraphMode }
{$F+}
function FalseDetect:Integer;
begin
 FalseDetect:=-1;
end;
{$F-}
begin
 GraphDriver:=InstallUserDriver('VGA256',@FalseDetect);
 GraphDriver:=InstallUserDriver('VESA16',@FalseDetect);
{$IFDEF MSDOS}
 GraphDriver:=InstallUserDriver('SVGA256',@FalseDetect);
{$ELSE}
 GraphDriver:=InstallUserDriver('BGI256',@FalseDetect);
{$ENDIF}
 GraphDriver:=Detect;
 BGIPAth:='';
 @InitError:=nil;
end.
